Codeforces Round #536 (Div. 2) B. Lunar New Year and Food Ordering

#include <bits/stdc++.h>
#define N 300010
#define PII pair<int, int>
using namespace std;

typedef long long LL;

int n, m, a[N], c[N], t, d;
LL ans = 0;

priority_queue<PII, vector<PII>, greater<PII> > Q;

int main(){
    scanf("%d%d", &n, &m);
    for (int i = 1; i <= n; i++){
        scanf("%d", &a[i]);
    }

    for (int i = 1; i <= n; i++){
        scanf("%d", &c[i]);
        Q.push(make_pair(c[i], i));
    }

    for (int i = 1; i <= m; i++){
        scanf("%d%d", &t, &d);
        if (d <= a[t]){
            a[t] -= d;
            printf("%lld\n", 1LL * d * c[t]);
        } else {
            bool flag = false;
            LL ans = 1LL * a[t] * c[t];
            d -= a[t];
            a[t] = 0;
            while (!Q.empty()){
                while (!Q.empty() && a[Q.top().second] == 0) Q.pop();
                if (Q.empty()) break;
                PII now = Q.top();
                if (d <= a[now.second]){
                    a[now.second] -= d;
                    ans += 1LL * d * now.first;
                    flag = true;
                    printf("%lld\n", ans);
                    break;
                } else {
                    ans += 1LL * a[now.second] * now.first;
                    d -= a[now.second];
                    a[now.second] = 0;
                    Q.pop();
                }
            }

            if (!flag){
                puts("0");
            }
        }
    }
}

以上是标准程序,只用了155ms,而下面的我的代码用了904ms。差距还是很大的,仔细看,发现是细节的优化。

#include<iostream>
#include<queue>
#include<algorithm>
#define pii pair<int,int>
using namespace std;
int num[100005];
int price[100005];
typedef long long LL;
priority_queue<pii,vector<pii>,greater<pii> > q;
int main(){
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++)
        cin>>num[i];
    for(int i=1;i<=n;i++){
        cin>>price[i];
        q.push(make_pair(price[i],i));
    }
    for(int i=0;i<m;i++){
        int t,d;
        cin>>t>>d;
        LL sum=0;
        int remain=d;
        if(num[t]>=d){
            sum+=1LL*d*price[t];
            num[t]-=d;
            remain=0;
        }
        else{
            sum+=1LL*num[t]*price[t];
            remain-=num[t];
            num[t]=0;
        }
        while(remain>0){
            if(q.empty()){
                cout<<0<<endl;
                break;
            }
            pii f=q.top();
            if(num[f.second]>remain){
                sum+=1LL*remain*f.first;
                num[f.second]-=remain;
                remain=0;
            }
            else{
                sum+=1LL*num[f.second]*f.first;
                remain-=num[f.second];
                num[f.second]=0;
                q.pop();
            }
        }
        if(remain==0)
            cout<<sum<<endl;
    }
    return 0;
}

原文地址:https://www.cnblogs.com/albert67/p/10369000.html

时间: 2024-08-29 06:47:11

Codeforces Round #536 (Div. 2) B. Lunar New Year and Food Ordering的相关文章

Codeforces Round #536 (Div. 2) - D. Lunar New Year and a Wander(最短路)

Problem  Codeforces Round #536 (Div. 2) - D. Lunar New Year and a Wander Time Limit: 3000 mSec Problem Description Input Output Output a line containing the lexicographically smallest sequence a1,a2,…,an Bob can record. Sample Input 3 21 21 3 Sample

Codeforces Round #536 (Div. 2)

目录 Codeforces Round #536 (Div. 2) A 题目大意 题解 卡点 C++ Code: B 题目大意 题解 卡点 C++ Code: C 题目大意 题解 卡点 C++ Code: D 题目大意 题解 卡点 C++ Code: E 题目大意 题解 卡点 C++ Code: F 题目大意 题解 卡点 C++ Code: Codeforces Round #536 (Div. 2) A 题目大意 给你一个\(n\times n(n\leqslant500)\)的矩阵,只包含.

Codeforces Round #536 (Div. 2) E dp + set

https://codeforces.com/contest/1106/problem/E 题意 一共有k个红包,每个红包在\([s_i,t_i]\)时间可以领取,假如领取了第i个红包,那么在\(d_i\)后才能领取下一个红包,每个红包价值\(w_i\),对方假如有机会领取红包他一定会领取,你有m次阻止对方领取的机会,问对方最少可以拿到多少红包 题解 定义dp[i][j]为前i秒用了j次机会让对方拿到最小价值的红包 \(dp[i][j] - > dp[i+1][j+1]\) 假如使用阻止 \(d

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f